require 'mechanize'

require "a_marmita/client_module"
require "a_marmita/payment"
require "a_marmita/version"
require "a_marmita/helpers"
require "a_marmita/scrapper"
require "a_marmita/web_agent"
require "a_marmita/cart/base"
require "a_marmita/meals/base"
require "a_marmita/orders/base"
require "a_marmita/authentication"

module AMarmita

  class Client

    include WebAgent
    include Authentication

    def cart
      @cart ||= Cart::Base.new(self)
    end

    def meals
      @meals ||= Meals::Base.new(self)
    end

    def orders
      @orders ||= Orders::Base.new(self)
    end

    def payment
      @payment ||= Payment.new(self)
    end

  end

  module ClassMethods

    def new_client
      Client.new
    end

    def singleton
      @singleton ||= Client.new
    end

    def method_missing(method, *args, &block)
      return super unless singleton.respond_to?(method)
      
      singleton.send(method, *args)
    end

  end

  extend ClassMethods
  
end
