module AMarmita
  module Cart

    class Scrapper < AMarmita::Scrapper
      
      DESCRIPTION, QUANTITY = 0, 1

      
      def run(options = {})
        @attributes = {
          date: options[:date],
          id: Helpers.to_int(get_id),
          description: get_description,
          quantity: Helpers.to_int(get_quantity)
        }
      end
      

      protected ############## PROTECTED ##################

      def get_id
        get_xml_value(css_parser.css('a').first) do |xml_object|
          get_id_from_javascript_function xml_object.attr('href')
        end
      end

      def get_description
        get_xml_value similar_entries[DESCRIPTION]
      end

      def get_quantity
        get_xml_value similar_entries[QUANTITY]
      end


      private ################# PRIVATE ##################

      def similar_entries
        @similar_entries ||= css_parser.css('.em_marmitalist_desc')
      end

      def get_id_from_javascript_function(javascript_function)
        id = javascript_function[(javascript_function.index('(') + 1)..-1]
        id[0..(id.index(')') - 1)]
      end

    end

  end
end
