module AMarmita
  module Meals

    class Scrapper < AMarmita::Scrapper

      def run(options = {})
        @attributes = {
          id: Helpers.to_int(get_id),
          name: get_name,
          type: get_type,
          price: get_price,
          description: get_description
        }
      end

      
      protected ############## PROTECTED ##################

      def get_id
        get_xml_value(css_parser.css('.em_add').first) do |xml_object|
          get_id_from_javascript_function xml_object.attr('onclick')
        end
      end

      def get_name
        get_xml_value css_parser.css('.em_nomeprato').first
      end

      def get_type
        get_xml_value(css_parser.css('.em_tipoprato > img').first) do |xml_object|
          xml_object.attr('src')
        end
      end

      def get_price
        get_xml_value css_parser.css('.em_preco').first
      end

      def get_description
        get_xml_value css_parser.css('.em_ingredientes').last
      end


      private ################# PRIVATE ##################

      def get_id_from_javascript_function(javascript_function)
        id = javascript_function[(javascript_function.index(',') + 1)..-1]
        id[0..(id.index(',') - 1)]
      end

    end

  end
end
