module AMarmita
  module Orders

    class Scrapper < AMarmita::Scrapper

      ORDER_DATE, ID, DETAILS, PRICE = 0, 1, 2, 3

      DELIVERY_DATA, NAME, QUANTITY = 0, 1, 2

      
      def run(options = {})
        @attributes = {
          name: get_name,
          id: Helpers.to_int(get_id),
          order_date: get_order_date,
          line: Helpers.to_int(get_line),
          delivery_date: get_delivery_date,
          price: Helpers.to_float(get_price),
          quantity: Helpers.to_int(get_quantity)
        }
      end

      
      protected ############## PROTECTED ##################

      def get_name
        get_xml_value details[NAME]
      end

      def get_id
        get_xml_value td_entries[ID]
      end

      def get_order_date
        get_xml_value td_entries[ORDER_DATE]
      end

      def get_line
        get_xml_value(css_parser.css('input').first) do |xml_object|
          get_line_from_javascript_function xml_object.attr('onclick')
        end
      end

      def get_delivery_date
        get_xml_value details[DELIVERY_DATA]
      end

      def get_price
        get_xml_value td_entries[PRICE]
      end

      def get_quantity
        get_xml_value details[QUANTITY]
      end


      private ################# PRIVATE ##################

      def td_entries
        @td_entries ||= css_parser.css('.texto100')
      end

      def details
        return [] if td_entries[DETAILS].nil?

        @details ||= td_entries[DETAILS].css('table td')
      end

      def get_line_from_javascript_function(javascript_function)
        javascript_function[(javascript_function.index(',') + 1)..-1]
      end

    end

  end
end
