module AMarmita
  
  class Scrapper

    attr_reader :attributes, :css_parser

    def initialize(css_parser)
      @attributes = { id: 0 }

      @css_parser = css_parser
    end

    def valid?
      @attributes[:id] > 0
    end

    def to_hash
      @attributes
    end

    def scrap(options = {})
      run(options)
      
      valid? ? @attributes : nil
    end

    def run(options = {})
      raise '#run must be implemented'
    end
    
    
    protected ############## PROTECTED ##################

    def get_xml_value(xml_object)
      return nil unless xml_object
      
      if block_given?
        yield(xml_object)
      else
        Helpers.try(xml_object, :text)
      end
    end

  end

end
